/* AspectImage.c generated by valac 0.56.3, the Vala compiler
 * generated from AspectImage.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "cawbird.h"
#include <stdlib.h>
#include <string.h>

#define TRANSITION_DURATION (200 * 1000)

#define TYPE_ASPECT_IMAGE (aspect_image_get_type ())
#define ASPECT_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASPECT_IMAGE, AspectImage))
#define ASPECT_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASPECT_IMAGE, AspectImageClass))
#define IS_ASPECT_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASPECT_IMAGE))
#define IS_ASPECT_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASPECT_IMAGE))
#define ASPECT_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASPECT_IMAGE, AspectImageClass))

typedef struct _AspectImage AspectImage;
typedef struct _AspectImageClass AspectImageClass;
typedef struct _AspectImagePrivate AspectImagePrivate;
enum  {
	ASPECT_IMAGE_0_PROPERTY,
	ASPECT_IMAGE_PIXBUF_PROPERTY,
	ASPECT_IMAGE_COLOR_STRING_PROPERTY,
	ASPECT_IMAGE_NUM_PROPERTIES
};
static GParamSpec* aspect_image_properties[ASPECT_IMAGE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _AspectImage {
	GtkWidget parent_instance;
	AspectImagePrivate * priv;
};

struct _AspectImageClass {
	GtkWidgetClass parent_class;
};

struct _AspectImagePrivate {
	GdkRGBA bg_color;
	cairo_surface_t* old_surface;
	cairo_surface_t* pixbuf_surface;
	gdouble alpha;
	gint64 start_time;
	gboolean in_transition;
};

static gint AspectImage_private_offset;
static gpointer aspect_image_parent_class = NULL;

VALA_EXTERN GType aspect_image_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AspectImage* aspect_image_new (void);
VALA_EXTERN AspectImage* aspect_image_construct (GType object_type);
static void aspect_image_start_animation (AspectImage* self);
static gboolean aspect_image_fade_in_cb (AspectImage* self,
                                  GtkWidget* widget,
                                  GdkFrameClock* frame_clock);
static gboolean _aspect_image_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                                     GdkFrameClock* frame_clock,
                                                     gpointer self);
VALA_EXTERN gdouble ease_out_cubic (gdouble t);
static void aspect_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                       gint width,
                                                       gint* min_height,
                                                       gint* nat_height);
static GtkSizeRequestMode aspect_image_real_get_request_mode (GtkWidget* base);
static gboolean aspect_image_real_draw (GtkWidget* base,
                                 cairo_t* ct);
VALA_EXTERN void aspect_image_set_pixbuf (AspectImage* self,
                              GdkPixbuf* value);
VALA_EXTERN void aspect_image_set_color_string (AspectImage* self,
                                    const gchar* value);
static GObject * aspect_image_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void aspect_image_finalize (GObject * obj);
static GType aspect_image_get_type_once (void);
static void _vala_aspect_image_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
aspect_image_get_instance_private (AspectImage* self)
{
	return G_STRUCT_MEMBER_P (self, AspectImage_private_offset);
}

AspectImage*
aspect_image_construct (GType object_type)
{
	AspectImage * self = NULL;
#line 48 "../src/widgets/AspectImage.vala"
	self = (AspectImage*) gtk_widget_new (object_type, NULL);
#line 48 "../src/widgets/AspectImage.vala"
	return self;
#line 124 "AspectImage.c"
}

AspectImage*
aspect_image_new (void)
{
#line 48 "../src/widgets/AspectImage.vala"
	return aspect_image_construct (TYPE_ASPECT_IMAGE);
#line 132 "AspectImage.c"
}

static gboolean
_aspect_image_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                            GdkFrameClock* frame_clock,
                                            gpointer self)
{
	gboolean result;
	result = aspect_image_fade_in_cb ((AspectImage*) self, widget, frame_clock);
#line 61 "../src/widgets/AspectImage.vala"
	return result;
#line 144 "AspectImage.c"
}

static void
aspect_image_start_animation (AspectImage* self)
{
	GdkFrameClock* _tmp0_;
#line 54 "../src/widgets/AspectImage.vala"
	g_return_if_fail (self != NULL);
#line 55 "../src/widgets/AspectImage.vala"
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
#line 56 "../src/widgets/AspectImage.vala"
		return;
#line 157 "AspectImage.c"
	}
#line 58 "../src/widgets/AspectImage.vala"
	self->priv->alpha = 0.0;
#line 59 "../src/widgets/AspectImage.vala"
	self->priv->in_transition = TRUE;
#line 60 "../src/widgets/AspectImage.vala"
	_tmp0_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
#line 60 "../src/widgets/AspectImage.vala"
	self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp0_);
#line 61 "../src/widgets/AspectImage.vala"
	gtk_widget_add_tick_callback ((GtkWidget*) self, _aspect_image_fade_in_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
#line 169 "AspectImage.c"
}

static gboolean
aspect_image_fade_in_cb (AspectImage* self,
                         GtkWidget* widget,
                         GdkFrameClock* frame_clock)
{
	gint64 now = 0LL;
	gdouble t = 0.0;
	gboolean result;
#line 67 "../src/widgets/AspectImage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 67 "../src/widgets/AspectImage.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 67 "../src/widgets/AspectImage.vala"
	g_return_val_if_fail (frame_clock != NULL, FALSE);
#line 68 "../src/widgets/AspectImage.vala"
	now = gdk_frame_clock_get_frame_time (frame_clock);
#line 69 "../src/widgets/AspectImage.vala"
	t = ((gdouble) (now - self->priv->start_time)) / TRANSITION_DURATION;
#line 71 "../src/widgets/AspectImage.vala"
	if (t >= 1.0) {
#line 72 "../src/widgets/AspectImage.vala"
		t = 1.0;
#line 73 "../src/widgets/AspectImage.vala"
		self->priv->in_transition = FALSE;
#line 196 "AspectImage.c"
	}
#line 76 "../src/widgets/AspectImage.vala"
	self->priv->alpha = ease_out_cubic (t);
#line 77 "../src/widgets/AspectImage.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 79 "../src/widgets/AspectImage.vala"
	result = t < 1.0;
#line 79 "../src/widgets/AspectImage.vala"
	return result;
#line 206 "AspectImage.c"
}

static void
aspect_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                  gint width,
                                                  gint* min_height,
                                                  gint* nat_height)
{
	AspectImage * self;
	gint _vala_min_height = 0;
	gint _vala_nat_height = 0;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
#line 82 "../src/widgets/AspectImage.vala"
	self = (AspectImage*) base;
#line 85 "../src/widgets/AspectImage.vala"
	_tmp0_ = self->priv->pixbuf_surface;
#line 85 "../src/widgets/AspectImage.vala"
	if (_tmp0_ == NULL) {
#line 86 "../src/widgets/AspectImage.vala"
		_vala_min_height = 0;
#line 87 "../src/widgets/AspectImage.vala"
		_vala_nat_height = 1;
#line 88 "../src/widgets/AspectImage.vala"
		if (min_height) {
#line 88 "../src/widgets/AspectImage.vala"
			*min_height = _vala_min_height;
#line 235 "AspectImage.c"
		}
#line 88 "../src/widgets/AspectImage.vala"
		if (nat_height) {
#line 88 "../src/widgets/AspectImage.vala"
			*nat_height = _vala_nat_height;
#line 241 "AspectImage.c"
		}
#line 88 "../src/widgets/AspectImage.vala"
		return;
#line 245 "AspectImage.c"
	}
#line 91 "../src/widgets/AspectImage.vala"
	_tmp1_ = self->priv->pixbuf_surface;
#line 91 "../src/widgets/AspectImage.vala"
	_vala_min_height = cairo_image_surface_get_height (_tmp1_);
#line 92 "../src/widgets/AspectImage.vala"
	_tmp2_ = self->priv->pixbuf_surface;
#line 92 "../src/widgets/AspectImage.vala"
	_vala_nat_height = cairo_image_surface_get_height (_tmp2_);
#line 82 "../src/widgets/AspectImage.vala"
	if (min_height) {
#line 82 "../src/widgets/AspectImage.vala"
		*min_height = _vala_min_height;
#line 259 "AspectImage.c"
	}
#line 82 "../src/widgets/AspectImage.vala"
	if (nat_height) {
#line 82 "../src/widgets/AspectImage.vala"
		*nat_height = _vala_nat_height;
#line 265 "AspectImage.c"
	}
}

static GtkSizeRequestMode
aspect_image_real_get_request_mode (GtkWidget* base)
{
	AspectImage * self;
	GtkSizeRequestMode result;
#line 96 "../src/widgets/AspectImage.vala"
	self = (AspectImage*) base;
#line 97 "../src/widgets/AspectImage.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 97 "../src/widgets/AspectImage.vala"
	return result;
#line 280 "AspectImage.c"
}

static gboolean
aspect_image_real_draw (GtkWidget* base,
                        cairo_t* ct)
{
	AspectImage * self;
	gint width = 0;
	gint height = 0;
	gdouble scale_x = 0.0;
	GdkRGBA _tmp0_;
	cairo_surface_t* _tmp2_;
	GdkRGBA _tmp9_;
	gboolean result;
#line 100 "../src/widgets/AspectImage.vala"
	self = (AspectImage*) base;
#line 100 "../src/widgets/AspectImage.vala"
	g_return_val_if_fail (ct != NULL, FALSE);
#line 101 "../src/widgets/AspectImage.vala"
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
#line 102 "../src/widgets/AspectImage.vala"
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
#line 104 "../src/widgets/AspectImage.vala"
	scale_x = 1.0;
#line 105 "../src/widgets/AspectImage.vala"
	_tmp0_ = self->priv->bg_color;
#line 105 "../src/widgets/AspectImage.vala"
	if (_tmp0_.alpha == 0.0) {
#line 309 "AspectImage.c"
		cairo_surface_t* _tmp1_;
#line 106 "../src/widgets/AspectImage.vala"
		_tmp1_ = self->priv->pixbuf_surface;
#line 106 "../src/widgets/AspectImage.vala"
		scale_x = width / ((gdouble) cairo_image_surface_get_width (_tmp1_));
#line 315 "AspectImage.c"
	}
#line 108 "../src/widgets/AspectImage.vala"
	scale_x = MAX (scale_x, 1.0);
#line 110 "../src/widgets/AspectImage.vala"
	cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
#line 111 "../src/widgets/AspectImage.vala"
	cairo_scale (ct, scale_x, 1.0);
#line 114 "../src/widgets/AspectImage.vala"
	cairo_push_group (ct);
#line 116 "../src/widgets/AspectImage.vala"
	_tmp2_ = self->priv->old_surface;
#line 116 "../src/widgets/AspectImage.vala"
	if (_tmp2_ != NULL) {
#line 329 "AspectImage.c"
		cairo_surface_t* _tmp3_;
#line 117 "../src/widgets/AspectImage.vala"
		_tmp3_ = self->priv->old_surface;
#line 117 "../src/widgets/AspectImage.vala"
		cairo_set_source_surface (ct, _tmp3_, (gdouble) 0, (gdouble) 0);
#line 118 "../src/widgets/AspectImage.vala"
		cairo_paint (ct);
#line 337 "AspectImage.c"
	} else {
		GdkRGBA _tmp4_;
#line 119 "../src/widgets/AspectImage.vala"
		_tmp4_ = self->priv->bg_color;
#line 119 "../src/widgets/AspectImage.vala"
		if (_tmp4_.alpha > 0.0) {
#line 344 "AspectImage.c"
			GdkRGBA _tmp5_;
			GdkRGBA _tmp6_;
			GdkRGBA _tmp7_;
			GdkRGBA _tmp8_;
#line 120 "../src/widgets/AspectImage.vala"
			_tmp5_ = self->priv->bg_color;
#line 120 "../src/widgets/AspectImage.vala"
			_tmp6_ = self->priv->bg_color;
#line 120 "../src/widgets/AspectImage.vala"
			_tmp7_ = self->priv->bg_color;
#line 120 "../src/widgets/AspectImage.vala"
			_tmp8_ = self->priv->bg_color;
#line 120 "../src/widgets/AspectImage.vala"
			cairo_set_source_rgba (ct, _tmp5_.red, _tmp6_.green, _tmp7_.blue, _tmp8_.alpha);
#line 121 "../src/widgets/AspectImage.vala"
			cairo_fill (ct);
#line 361 "AspectImage.c"
		} else {
#line 123 "../src/widgets/AspectImage.vala"
			self->priv->alpha = 1.0;
#line 365 "AspectImage.c"
		}
	}
#line 126 "../src/widgets/AspectImage.vala"
	_tmp9_ = self->priv->bg_color;
#line 126 "../src/widgets/AspectImage.vala"
	if (_tmp9_.alpha == 0.0) {
#line 372 "AspectImage.c"
		gint x = 0;
		cairo_surface_t* _tmp10_;
		cairo_surface_t* _tmp11_;
#line 127 "../src/widgets/AspectImage.vala"
		_tmp10_ = self->priv->pixbuf_surface;
#line 127 "../src/widgets/AspectImage.vala"
		x = ((gint) (width - (cairo_image_surface_get_width (_tmp10_) * scale_x))) / 2;
#line 128 "../src/widgets/AspectImage.vala"
		_tmp11_ = self->priv->pixbuf_surface;
#line 128 "../src/widgets/AspectImage.vala"
		cairo_set_source_surface (ct, _tmp11_, (gdouble) x, (gdouble) 0);
#line 384 "AspectImage.c"
	} else {
		GdkRGBA _tmp12_;
		GdkRGBA _tmp13_;
		GdkRGBA _tmp14_;
		GdkRGBA _tmp15_;
#line 130 "../src/widgets/AspectImage.vala"
		_tmp12_ = self->priv->bg_color;
#line 130 "../src/widgets/AspectImage.vala"
		_tmp13_ = self->priv->bg_color;
#line 130 "../src/widgets/AspectImage.vala"
		_tmp14_ = self->priv->bg_color;
#line 130 "../src/widgets/AspectImage.vala"
		_tmp15_ = self->priv->bg_color;
#line 130 "../src/widgets/AspectImage.vala"
		cairo_set_source_rgba (ct, _tmp12_.red, _tmp13_.green, _tmp14_.blue, _tmp15_.alpha);
#line 400 "AspectImage.c"
	}
#line 132 "../src/widgets/AspectImage.vala"
	if (self->priv->in_transition) {
#line 133 "../src/widgets/AspectImage.vala"
		cairo_paint_with_alpha (ct, self->priv->alpha);
#line 406 "AspectImage.c"
	} else {
#line 135 "../src/widgets/AspectImage.vala"
		cairo_paint (ct);
#line 410 "AspectImage.c"
	}
#line 137 "../src/widgets/AspectImage.vala"
	cairo_pop_group_to_source (ct);
#line 139 "../src/widgets/AspectImage.vala"
	cairo_set_operator (ct, CAIRO_OPERATOR_OVER);
#line 140 "../src/widgets/AspectImage.vala"
	cairo_paint (ct);
#line 142 "../src/widgets/AspectImage.vala"
	result = GDK_EVENT_PROPAGATE;
#line 142 "../src/widgets/AspectImage.vala"
	return result;
#line 422 "AspectImage.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 28 "../src/widgets/AspectImage.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 430 "AspectImage.c"
}

void
aspect_image_set_pixbuf (AspectImage* self,
                         GdkPixbuf* value)
{
#line 20 "../src/widgets/AspectImage.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/widgets/AspectImage.vala"
	if (value != NULL) {
#line 441 "AspectImage.c"
		GdkPixbuf* _tmp0_;
		cairo_surface_t* _tmp1_;
		GdkWindow* _tmp4_;
		cairo_surface_t* _tmp5_;
#line 23 "../src/widgets/AspectImage.vala"
		_tmp0_ = twitter_no_banner;
#line 23 "../src/widgets/AspectImage.vala"
		if (value != _tmp0_) {
#line 24 "../src/widgets/AspectImage.vala"
			aspect_image_start_animation (self);
#line 452 "AspectImage.c"
		}
#line 27 "../src/widgets/AspectImage.vala"
		_tmp1_ = self->priv->pixbuf_surface;
#line 27 "../src/widgets/AspectImage.vala"
		if (_tmp1_ != NULL) {
#line 458 "AspectImage.c"
			cairo_surface_t* _tmp2_;
			cairo_surface_t* _tmp3_;
#line 28 "../src/widgets/AspectImage.vala"
			_tmp2_ = self->priv->pixbuf_surface;
#line 28 "../src/widgets/AspectImage.vala"
			_tmp3_ = _cairo_surface_reference0 (_tmp2_);
#line 28 "../src/widgets/AspectImage.vala"
			_cairo_surface_destroy0 (self->priv->old_surface);
#line 28 "../src/widgets/AspectImage.vala"
			self->priv->old_surface = _tmp3_;
#line 469 "AspectImage.c"
		}
#line 30 "../src/widgets/AspectImage.vala"
		_tmp4_ = gtk_widget_get_window ((GtkWidget*) self);
#line 30 "../src/widgets/AspectImage.vala"
		_tmp5_ = gdk_cairo_surface_create_from_pixbuf (value, 1, _tmp4_);
#line 30 "../src/widgets/AspectImage.vala"
		_cairo_surface_destroy0 (self->priv->pixbuf_surface);
#line 30 "../src/widgets/AspectImage.vala"
		self->priv->pixbuf_surface = (cairo_surface_t*) _tmp5_;
#line 32 "../src/widgets/AspectImage.vala"
		self->priv->bg_color.alpha = 0.0;
#line 481 "AspectImage.c"
	}
#line 34 "../src/widgets/AspectImage.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 20 "../src/widgets/AspectImage.vala"
	g_object_notify_by_pspec ((GObject *) self, aspect_image_properties[ASPECT_IMAGE_PIXBUF_PROPERTY]);
#line 487 "AspectImage.c"
}

void
aspect_image_set_color_string (AspectImage* self,
                               const gchar* value)
{
#line 38 "../src/widgets/AspectImage.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/widgets/AspectImage.vala"
	gdk_rgba_parse (&self->priv->bg_color, value);
#line 38 "../src/widgets/AspectImage.vala"
	g_object_notify_by_pspec ((GObject *) self, aspect_image_properties[ASPECT_IMAGE_COLOR_STRING_PROPERTY]);
#line 500 "AspectImage.c"
}

static GObject *
aspect_image_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AspectImage * self;
#line 50 "../src/widgets/AspectImage.vala"
	parent_class = G_OBJECT_CLASS (aspect_image_parent_class);
#line 50 "../src/widgets/AspectImage.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 50 "../src/widgets/AspectImage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASPECT_IMAGE, AspectImage);
#line 51 "../src/widgets/AspectImage.vala"
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
#line 50 "../src/widgets/AspectImage.vala"
	return obj;
#line 521 "AspectImage.c"
}

static void
aspect_image_class_init (AspectImageClass * klass,
                         gpointer klass_data)
{
#line 18 "../src/widgets/AspectImage.vala"
	aspect_image_parent_class = g_type_class_peek_parent (klass);
#line 18 "../src/widgets/AspectImage.vala"
	g_type_class_adjust_private_offset (klass, &AspectImage_private_offset);
#line 18 "../src/widgets/AspectImage.vala"
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) aspect_image_real_get_preferred_height_for_width;
#line 18 "../src/widgets/AspectImage.vala"
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) aspect_image_real_get_request_mode;
#line 18 "../src/widgets/AspectImage.vala"
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) aspect_image_real_draw;
#line 18 "../src/widgets/AspectImage.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_aspect_image_set_property;
#line 18 "../src/widgets/AspectImage.vala"
	G_OBJECT_CLASS (klass)->constructor = aspect_image_constructor;
#line 18 "../src/widgets/AspectImage.vala"
	G_OBJECT_CLASS (klass)->finalize = aspect_image_finalize;
#line 18 "../src/widgets/AspectImage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASPECT_IMAGE_PIXBUF_PROPERTY, aspect_image_properties[ASPECT_IMAGE_PIXBUF_PROPERTY] = g_param_spec_object ("pixbuf", "pixbuf", "pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 18 "../src/widgets/AspectImage.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASPECT_IMAGE_COLOR_STRING_PROPERTY, aspect_image_properties[ASPECT_IMAGE_COLOR_STRING_PROPERTY] = g_param_spec_string ("color-string", "color-string", "color-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 548 "AspectImage.c"
}

static void
aspect_image_instance_init (AspectImage * self,
                            gpointer klass)
{
#line 18 "../src/widgets/AspectImage.vala"
	self->priv = aspect_image_get_instance_private (self);
#line 45 "../src/widgets/AspectImage.vala"
	self->priv->pixbuf_surface = NULL;
#line 64 "../src/widgets/AspectImage.vala"
	self->priv->alpha = 0.0;
#line 66 "../src/widgets/AspectImage.vala"
	self->priv->in_transition = FALSE;
#line 563 "AspectImage.c"
}

static void
aspect_image_finalize (GObject * obj)
{
	AspectImage * self;
#line 18 "../src/widgets/AspectImage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASPECT_IMAGE, AspectImage);
#line 44 "../src/widgets/AspectImage.vala"
	_cairo_surface_destroy0 (self->priv->old_surface);
#line 45 "../src/widgets/AspectImage.vala"
	_cairo_surface_destroy0 (self->priv->pixbuf_surface);
#line 18 "../src/widgets/AspectImage.vala"
	G_OBJECT_CLASS (aspect_image_parent_class)->finalize (obj);
#line 578 "AspectImage.c"
}

static GType
aspect_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AspectImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) aspect_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AspectImage), 0, (GInstanceInitFunc) aspect_image_instance_init, NULL };
	GType aspect_image_type_id;
	aspect_image_type_id = g_type_register_static (gtk_widget_get_type (), "AspectImage", &g_define_type_info, 0);
	AspectImage_private_offset = g_type_add_instance_private (aspect_image_type_id, sizeof (AspectImagePrivate));
	return aspect_image_type_id;
}

GType
aspect_image_get_type (void)
{
	static volatile gsize aspect_image_type_id__once = 0;
	if (g_once_init_enter (&aspect_image_type_id__once)) {
		GType aspect_image_type_id;
		aspect_image_type_id = aspect_image_get_type_once ();
		g_once_init_leave (&aspect_image_type_id__once, aspect_image_type_id);
	}
	return aspect_image_type_id__once;
}

static void
_vala_aspect_image_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	AspectImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASPECT_IMAGE, AspectImage);
#line 18 "../src/widgets/AspectImage.vala"
	switch (property_id) {
#line 18 "../src/widgets/AspectImage.vala"
		case ASPECT_IMAGE_PIXBUF_PROPERTY:
#line 18 "../src/widgets/AspectImage.vala"
		aspect_image_set_pixbuf (self, g_value_get_object (value));
#line 18 "../src/widgets/AspectImage.vala"
		break;
#line 18 "../src/widgets/AspectImage.vala"
		case ASPECT_IMAGE_COLOR_STRING_PROPERTY:
#line 18 "../src/widgets/AspectImage.vala"
		aspect_image_set_color_string (self, g_value_get_string (value));
#line 18 "../src/widgets/AspectImage.vala"
		break;
#line 625 "AspectImage.c"
		default:
#line 18 "../src/widgets/AspectImage.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 18 "../src/widgets/AspectImage.vala"
		break;
#line 631 "AspectImage.c"
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

