/* ImageDescriptionWindow.c generated by valac 0.56.3, the Vala compiler
 * generated from ImageDescriptionWindow.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2020 IBBoard
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <rest/oauth-proxy.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include "libtl/libtweetlength.h"
#include <atk/atk.h>
#include <glib/gi18n-lib.h>
#include "cawbird.h"
#include <json-glib/json-glib.h>
#include <rest/rest-proxy.h>
#include <rest/rest-proxy-call.h>

#define IMAGE_DESCRIPTION_WINDOW_DEFAULT_WIDTH 450
#define IMAGE_DESCRIPTION_WINDOW_MAX_DESCRIPTION_LENGTH 1000

#define TYPE_IMAGE_DESCRIPTION_WINDOW (image_description_window_get_type ())
#define IMAGE_DESCRIPTION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_DESCRIPTION_WINDOW, ImageDescriptionWindow))
#define IMAGE_DESCRIPTION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_DESCRIPTION_WINDOW, ImageDescriptionWindowClass))
#define IS_IMAGE_DESCRIPTION_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_DESCRIPTION_WINDOW))
#define IS_IMAGE_DESCRIPTION_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_DESCRIPTION_WINDOW))
#define IMAGE_DESCRIPTION_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_DESCRIPTION_WINDOW, ImageDescriptionWindowClass))

typedef struct _ImageDescriptionWindow ImageDescriptionWindow;
typedef struct _ImageDescriptionWindowClass ImageDescriptionWindowClass;
typedef struct _ImageDescriptionWindowPrivate ImageDescriptionWindowPrivate;

#define TYPE_RESIZABLE_IMAGE (resizable_image_get_type ())
#define RESIZABLE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RESIZABLE_IMAGE, ResizableImage))
#define RESIZABLE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RESIZABLE_IMAGE, ResizableImageClass))
#define IS_RESIZABLE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RESIZABLE_IMAGE))
#define IS_RESIZABLE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RESIZABLE_IMAGE))
#define RESIZABLE_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RESIZABLE_IMAGE, ResizableImageClass))

typedef struct _ResizableImage ResizableImage;
typedef struct _ResizableImageClass ResizableImageClass;
enum  {
	IMAGE_DESCRIPTION_WINDOW_0_PROPERTY,
	IMAGE_DESCRIPTION_WINDOW_NUM_PROPERTIES
};
static GParamSpec* image_description_window_properties[IMAGE_DESCRIPTION_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ResizableImagePrivate ResizableImagePrivate;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block96Data Block96Data;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
typedef struct _ImageDescriptionWindowSetImageDescriptionData ImageDescriptionWindowSetImageDescriptionData;
enum  {
	IMAGE_DESCRIPTION_WINDOW_DESCRIPTION_UPDATED_SIGNAL,
	IMAGE_DESCRIPTION_WINDOW_NUM_SIGNALS
};
static guint image_description_window_signals[IMAGE_DESCRIPTION_WINDOW_NUM_SIGNALS] = {0};

struct _ImageDescriptionWindow {
	GtkWindow parent_instance;
	ImageDescriptionWindowPrivate * priv;
};

struct _ImageDescriptionWindowClass {
	GtkWindowClass parent_class;
};

struct _ImageDescriptionWindowPrivate {
	ResizableImage* image;
	GtkTextView* description_text;
	GtkLabel* length_label;
	GtkButton* save_button;
	GtkSpinner* title_spinner;
	GtkLabel* title_label;
	GtkStack* title_stack;
	OAuthProxy* proxy;
	GCancellable* cancellable;
	gint64 media_id;
};

struct _ResizableImage {
	GtkImage parent_instance;
	ResizableImagePrivate * priv;
	cairo_surface_t* image_surface;
};

struct _ResizableImageClass {
	GtkImageClass parent_class;
};

struct _Block96Data {
	int _ref_count_;
	ImageDescriptionWindow* self;
	OAuthProxyCallWithBody* call;
	GError* err;
	gpointer _async_data_;
};

struct _ImageDescriptionWindowSetImageDescriptionData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	ImageDescriptionWindow* self;
	Block96Data* _data96_;
	JsonGenerator* gen;
	JsonGenerator* _tmp0_;
	JsonNode* root;
	JsonNode* _tmp1_;
	JsonObject* object;
	JsonObject* _tmp2_;
	JsonNode* _tmp3_;
	JsonObject* _tmp4_;
	JsonGenerator* _tmp5_;
	JsonNode* _tmp6_;
	JsonObject* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	JsonObject* alt_text;
	JsonObject* _tmp10_;
	JsonObject* _tmp11_;
	JsonObject* _tmp12_;
	JsonObject* _tmp13_;
	JsonObject* _tmp14_;
	GtkTextView* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GtkTextBuffer* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* json_dump;
	JsonGenerator* _tmp21_;
	gchar* _tmp22_;
	const gchar* _tmp23_;
	OAuthProxy* _tmp24_;
	const gchar* _tmp25_;
	OAuthProxyCallWithBody* _tmp26_;
	OAuthProxyCallWithBody* _tmp27_;
	OAuthProxyCallWithBody* _tmp28_;
	OAuthProxyCallWithBody* _tmp29_;
	GError* _tmp30_;
	GError* _tmp31_;
	GError* _tmp32_;
	GError* _inner_error0_;
};

static gint ImageDescriptionWindow_private_offset;
static gpointer image_description_window_parent_class = NULL;

VALA_EXTERN GType image_description_window_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType resizable_image_get_type (void) G_GNUC_CONST ;
VALA_EXTERN ImageDescriptionWindow* image_description_window_new (GtkWindow* parent,
                                                      OAuthProxy* proxy,
                                                      gint64 media_id,
                                                      const gchar* description,
                                                      cairo_surface_t* image_surface);
VALA_EXTERN ImageDescriptionWindow* image_description_window_construct (GType object_type,
                                                            GtkWindow* parent,
                                                            OAuthProxy* proxy,
                                                            gint64 media_id,
                                                            const gchar* description,
                                                            cairo_surface_t* image_surface);
static void image_description_window_update_save_button_sensitivity (ImageDescriptionWindow* self);
static void _image_description_window_update_save_button_sensitivity_g_object_notify (GObject* _sender,
                                                                               GParamSpec* pspec,
                                                                               gpointer self);
static void __lambda45_ (ImageDescriptionWindow* self);
static void ___lambda45__gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                           gpointer self);
static gboolean image_description_window_escape_pressed_cb (ImageDescriptionWindow* self);
static gboolean _image_description_window_escape_pressed_cb_gtk_accel_group_activate (GtkAccelGroup* accel_group,
                                                                               GObject* acceleratable,
                                                                               guint keyval,
                                                                               GdkModifierType modifier,
                                                                               gpointer self);
static gboolean __lambda46_ (ImageDescriptionWindow* self);
static void image_description_window_save_image_description_clicked (ImageDescriptionWindow* self);
static gboolean ___lambda46__gtk_accel_group_activate (GtkAccelGroup* accel_group,
                                                GObject* acceleratable,
                                                guint keyval,
                                                GdkModifierType modifier,
                                                gpointer self);
static void image_description_window_set_sending_state (ImageDescriptionWindow* self,
                                                 gboolean sending);
static void image_description_window_set_image_description (ImageDescriptionWindow* self,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_);
static void image_description_window_set_image_description_finish (ImageDescriptionWindow* self,
                                                            GAsyncResult* _res_,
                                                            GError** error);
static void __lambda48_ (ImageDescriptionWindow* self,
                  GObject* obj,
                  GAsyncResult* res);
VALA_EXTERN void utils_show_error_dialog (GError* e,
                              GtkWindow* transient_for,
                              const gchar* file,
                              gint line);
static void ___lambda48__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _image_description_window_save_image_description_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                                  gpointer self);
static void image_description_window_set_image_description_data_free (gpointer _data);
static gboolean image_description_window_set_image_description_co (ImageDescriptionWindowSetImageDescriptionData* _data_);
static Block96Data* block96_data_ref (Block96Data* _data96_);
static void block96_data_unref (void * _userdata_);
static void __lambda47_ (Block96Data* _data96_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda47__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void _vala_JsonNode_free (JsonNode* self);
static void image_description_window_cancel_clicked (ImageDescriptionWindow* self);
static void _image_description_window_cancel_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void g_cclosure_user_marshal_VOID__INT64_STRING (GClosure * closure,
                                                 GValue * return_value,
                                                 guint n_param_values,
                                                 const GValue * param_values,
                                                 gpointer invocation_hint,
                                                 gpointer marshal_data);
static void image_description_window_finalize (GObject * obj);
static GType image_description_window_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
image_description_window_get_instance_private (ImageDescriptionWindow* self)
{
	return G_STRUCT_MEMBER_P (self, ImageDescriptionWindow_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 46 "../src/window/ImageDescriptionWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 262 "ImageDescriptionWindow.c"
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 47 "../src/window/ImageDescriptionWindow.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 270 "ImageDescriptionWindow.c"
}

static void
_image_description_window_update_save_button_sensitivity_g_object_notify (GObject* _sender,
                                                                          GParamSpec* pspec,
                                                                          gpointer self)
{
#line 53 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_update_save_button_sensitivity ((ImageDescriptionWindow*) self);
#line 280 "ImageDescriptionWindow.c"
}

static void
__lambda45_ (ImageDescriptionWindow* self)
{
#line 56 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_update_save_button_sensitivity (self);
#line 288 "ImageDescriptionWindow.c"
}

static void
___lambda45__gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                      gpointer self)
{
#line 55 "../src/window/ImageDescriptionWindow.vala"
	__lambda45_ ((ImageDescriptionWindow*) self);
#line 297 "ImageDescriptionWindow.c"
}

static gboolean
_image_description_window_escape_pressed_cb_gtk_accel_group_activate (GtkAccelGroup* accel_group,
                                                                      GObject* acceleratable,
                                                                      guint keyval,
                                                                      GdkModifierType modifier,
                                                                      gpointer self)
{
	gboolean result;
	result = image_description_window_escape_pressed_cb ((ImageDescriptionWindow*) self);
#line 67 "../src/window/ImageDescriptionWindow.vala"
	return result;
#line 311 "ImageDescriptionWindow.c"
}

static gboolean
__lambda46_ (ImageDescriptionWindow* self)
{
	gboolean result;
#line 69 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_save_image_description_clicked (self);
#line 69 "../src/window/ImageDescriptionWindow.vala"
	result = TRUE;
#line 69 "../src/window/ImageDescriptionWindow.vala"
	return result;
#line 324 "ImageDescriptionWindow.c"
}

static gboolean
___lambda46__gtk_accel_group_activate (GtkAccelGroup* accel_group,
                                       GObject* acceleratable,
                                       guint keyval,
                                       GdkModifierType modifier,
                                       gpointer self)
{
	gboolean result;
	result = __lambda46_ ((ImageDescriptionWindow*) self);
#line 68 "../src/window/ImageDescriptionWindow.vala"
	return result;
#line 338 "ImageDescriptionWindow.c"
}

ImageDescriptionWindow*
image_description_window_construct (GType object_type,
                                    GtkWindow* parent,
                                    OAuthProxy* proxy,
                                    gint64 media_id,
                                    const gchar* description,
                                    cairo_surface_t* image_surface)
{
	ImageDescriptionWindow * self = NULL;
	OAuthProxy* _tmp0_;
	ResizableImage* _tmp1_;
	cairo_surface_t* _tmp2_;
	GtkTextView* _tmp3_;
	GtkTextBuffer* _tmp4_;
	GtkTextBuffer* _tmp5_;
	GCancellable* _tmp6_;
	GtkLabel* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	GNetworkMonitor* _tmp10_;
	GtkTextView* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextBuffer* _tmp13_;
	GtkTextView* _tmp14_;
	GtkAccelGroup* ag = NULL;
	GtkAccelGroup* _tmp15_;
#line 44 "../src/window/ImageDescriptionWindow.vala"
	g_return_val_if_fail (proxy != NULL, NULL);
#line 44 "../src/window/ImageDescriptionWindow.vala"
	g_return_val_if_fail (description != NULL, NULL);
#line 44 "../src/window/ImageDescriptionWindow.vala"
	g_return_val_if_fail (image_surface != NULL, NULL);
#line 44 "../src/window/ImageDescriptionWindow.vala"
	self = (ImageDescriptionWindow*) g_object_new (object_type, NULL);
#line 45 "../src/window/ImageDescriptionWindow.vala"
	self->priv->media_id = media_id;
#line 46 "../src/window/ImageDescriptionWindow.vala"
	_tmp0_ = _g_object_ref0 (proxy);
#line 46 "../src/window/ImageDescriptionWindow.vala"
	_g_object_unref0 (self->priv->proxy);
#line 46 "../src/window/ImageDescriptionWindow.vala"
	self->priv->proxy = _tmp0_;
#line 47 "../src/window/ImageDescriptionWindow.vala"
	_tmp1_ = self->priv->image;
#line 47 "../src/window/ImageDescriptionWindow.vala"
	_tmp2_ = _cairo_surface_reference0 (image_surface);
#line 47 "../src/window/ImageDescriptionWindow.vala"
	_cairo_surface_destroy0 (_tmp1_->image_surface);
#line 47 "../src/window/ImageDescriptionWindow.vala"
	_tmp1_->image_surface = _tmp2_;
#line 48 "../src/window/ImageDescriptionWindow.vala"
	_tmp3_ = self->priv->description_text;
#line 48 "../src/window/ImageDescriptionWindow.vala"
	_tmp4_ = gtk_text_view_get_buffer (_tmp3_);
#line 48 "../src/window/ImageDescriptionWindow.vala"
	_tmp5_ = _tmp4_;
#line 48 "../src/window/ImageDescriptionWindow.vala"
	g_object_set (_tmp5_, "text", description, NULL);
#line 49 "../src/window/ImageDescriptionWindow.vala"
	_tmp6_ = g_cancellable_new ();
#line 49 "../src/window/ImageDescriptionWindow.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 49 "../src/window/ImageDescriptionWindow.vala"
	self->priv->cancellable = _tmp6_;
#line 51 "../src/window/ImageDescriptionWindow.vala"
	_tmp7_ = self->priv->length_label;
#line 51 "../src/window/ImageDescriptionWindow.vala"
	_tmp8_ = g_strdup_printf ("%i", IMAGE_DESCRIPTION_WINDOW_MAX_DESCRIPTION_LENGTH);
#line 51 "../src/window/ImageDescriptionWindow.vala"
	_tmp9_ = _tmp8_;
#line 51 "../src/window/ImageDescriptionWindow.vala"
	gtk_label_set_label (_tmp7_, _tmp9_);
#line 51 "../src/window/ImageDescriptionWindow.vala"
	_g_free0 (_tmp9_);
#line 53 "../src/window/ImageDescriptionWindow.vala"
	_tmp10_ = g_network_monitor_get_default ();
#line 53 "../src/window/ImageDescriptionWindow.vala"
	g_signal_connect_object ((GObject*) _tmp10_, "notify::network-available", (GCallback) _image_description_window_update_save_button_sensitivity_g_object_notify, self, 0);
#line 55 "../src/window/ImageDescriptionWindow.vala"
	_tmp11_ = self->priv->description_text;
#line 55 "../src/window/ImageDescriptionWindow.vala"
	_tmp12_ = gtk_text_view_get_buffer (_tmp11_);
#line 55 "../src/window/ImageDescriptionWindow.vala"
	_tmp13_ = _tmp12_;
#line 55 "../src/window/ImageDescriptionWindow.vala"
	g_signal_connect_object (_tmp13_, "changed", (GCallback) ___lambda45__gtk_text_buffer_changed, self, 0);
#line 59 "../src/window/ImageDescriptionWindow.vala"
	if (parent != NULL) {
#line 60 "../src/window/ImageDescriptionWindow.vala"
		gtk_window_set_transient_for ((GtkWindow*) self, parent);
#line 61 "../src/window/ImageDescriptionWindow.vala"
		gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 433 "ImageDescriptionWindow.c"
	}
#line 65 "../src/window/ImageDescriptionWindow.vala"
	_tmp14_ = self->priv->description_text;
#line 65 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_grab_focus ((GtkWidget*) _tmp14_);
#line 66 "../src/window/ImageDescriptionWindow.vala"
	_tmp15_ = gtk_accel_group_new ();
#line 66 "../src/window/ImageDescriptionWindow.vala"
	ag = _tmp15_;
#line 67 "../src/window/ImageDescriptionWindow.vala"
	gtk_accel_group_connect (ag, GDK_KEY_Escape, 0, GTK_ACCEL_LOCKED, (GClosure*) ((_image_description_window_escape_pressed_cb_gtk_accel_group_activate == NULL) ? NULL : g_cclosure_new ((GCallback) _image_description_window_escape_pressed_cb_gtk_accel_group_activate, g_object_ref (self), (GClosureNotify) g_object_unref)));
#line 68 "../src/window/ImageDescriptionWindow.vala"
	gtk_accel_group_connect (ag, GDK_KEY_Return, GDK_CONTROL_MASK, GTK_ACCEL_LOCKED, (GClosure*) ((___lambda46__gtk_accel_group_activate == NULL) ? NULL : g_cclosure_new ((GCallback) ___lambda46__gtk_accel_group_activate, g_object_ref (self), (GClosureNotify) g_object_unref)));
#line 71 "../src/window/ImageDescriptionWindow.vala"
	gtk_window_add_accel_group ((GtkWindow*) self, ag);
#line 73 "../src/window/ImageDescriptionWindow.vala"
	gtk_window_set_default_size ((GtkWindow*) self, IMAGE_DESCRIPTION_WINDOW_DEFAULT_WIDTH, (gint) (IMAGE_DESCRIPTION_WINDOW_DEFAULT_WIDTH / 1.5));
#line 74 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_update_save_button_sensitivity (self);
#line 44 "../src/window/ImageDescriptionWindow.vala"
	_g_object_unref0 (ag);
#line 44 "../src/window/ImageDescriptionWindow.vala"
	return self;
#line 457 "ImageDescriptionWindow.c"
}

ImageDescriptionWindow*
image_description_window_new (GtkWindow* parent,
                              OAuthProxy* proxy,
                              gint64 media_id,
                              const gchar* description,
                              cairo_surface_t* image_surface)
{
#line 44 "../src/window/ImageDescriptionWindow.vala"
	return image_description_window_construct (TYPE_IMAGE_DESCRIPTION_WINDOW, parent, proxy, media_id, description, image_surface);
#line 469 "ImageDescriptionWindow.c"
}

static void
image_description_window_update_save_button_sensitivity (ImageDescriptionWindow* self)
{
	gint length = 0;
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gint chars_remaining = 0;
	GtkLabel* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	GtkLabel* _tmp15_;
	AtkObject* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
#line 77 "../src/window/ImageDescriptionWindow.vala"
	g_return_if_fail (self != NULL);
#line 78 "../src/window/ImageDescriptionWindow.vala"
	_tmp0_ = self->priv->description_text;
#line 78 "../src/window/ImageDescriptionWindow.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 78 "../src/window/ImageDescriptionWindow.vala"
	_tmp2_ = _tmp1_;
#line 78 "../src/window/ImageDescriptionWindow.vala"
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
#line 78 "../src/window/ImageDescriptionWindow.vala"
	_tmp4_ = _tmp3_;
#line 78 "../src/window/ImageDescriptionWindow.vala"
	_tmp5_ = _tmp4_;
#line 78 "../src/window/ImageDescriptionWindow.vala"
	_tmp6_ = (gint) tl_count_weighted_characters (_tmp5_, FALSE);
#line 78 "../src/window/ImageDescriptionWindow.vala"
	_g_free0 (_tmp5_);
#line 78 "../src/window/ImageDescriptionWindow.vala"
	length = _tmp6_;
#line 80 "../src/window/ImageDescriptionWindow.vala"
	if (length <= IMAGE_DESCRIPTION_WINDOW_MAX_DESCRIPTION_LENGTH) {
#line 513 "ImageDescriptionWindow.c"
		GtkButton* _tmp7_;
		GNetworkMonitor* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 81 "../src/window/ImageDescriptionWindow.vala"
		_tmp7_ = self->priv->save_button;
#line 81 "../src/window/ImageDescriptionWindow.vala"
		_tmp8_ = g_network_monitor_get_default ();
#line 81 "../src/window/ImageDescriptionWindow.vala"
		_tmp9_ = g_network_monitor_get_network_available (_tmp8_);
#line 81 "../src/window/ImageDescriptionWindow.vala"
		_tmp10_ = _tmp9_;
#line 81 "../src/window/ImageDescriptionWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, _tmp10_);
#line 528 "ImageDescriptionWindow.c"
	} else {
		GtkButton* _tmp11_;
#line 83 "../src/window/ImageDescriptionWindow.vala"
		_tmp11_ = self->priv->save_button;
#line 83 "../src/window/ImageDescriptionWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp11_, FALSE);
#line 535 "ImageDescriptionWindow.c"
	}
#line 86 "../src/window/ImageDescriptionWindow.vala"
	chars_remaining = IMAGE_DESCRIPTION_WINDOW_MAX_DESCRIPTION_LENGTH - length;
#line 87 "../src/window/ImageDescriptionWindow.vala"
	_tmp12_ = self->priv->length_label;
#line 87 "../src/window/ImageDescriptionWindow.vala"
	_tmp13_ = g_strdup_printf ("%i", chars_remaining);
#line 87 "../src/window/ImageDescriptionWindow.vala"
	_tmp14_ = _tmp13_;
#line 87 "../src/window/ImageDescriptionWindow.vala"
	gtk_label_set_label (_tmp12_, _tmp14_);
#line 87 "../src/window/ImageDescriptionWindow.vala"
	_g_free0 (_tmp14_);
#line 88 "../src/window/ImageDescriptionWindow.vala"
	_tmp15_ = self->priv->length_label;
#line 88 "../src/window/ImageDescriptionWindow.vala"
	_tmp16_ = gtk_widget_get_accessible ((GtkWidget*) _tmp15_);
#line 88 "../src/window/ImageDescriptionWindow.vala"
	_tmp17_ = g_strdup_printf (ngettext ("%d character remaining", "%d characters remaining", (gulong) chars_remaining), (gint) chars_remaining);
#line 88 "../src/window/ImageDescriptionWindow.vala"
	_tmp18_ = _tmp17_;
#line 88 "../src/window/ImageDescriptionWindow.vala"
	atk_object_set_description (_tmp16_, _tmp18_);
#line 88 "../src/window/ImageDescriptionWindow.vala"
	_g_free0 (_tmp18_);
#line 561 "ImageDescriptionWindow.c"
}

static void
image_description_window_set_sending_state (ImageDescriptionWindow* self,
                                            gboolean sending)
{
	GtkTextView* _tmp7_;
#line 91 "../src/window/ImageDescriptionWindow.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/window/ImageDescriptionWindow.vala"
	if (sending) {
#line 573 "ImageDescriptionWindow.c"
		GtkStack* _tmp0_;
		GtkSpinner* _tmp1_;
		GtkSpinner* _tmp2_;
		GtkButton* _tmp3_;
#line 93 "../src/window/ImageDescriptionWindow.vala"
		_tmp0_ = self->priv->title_stack;
#line 93 "../src/window/ImageDescriptionWindow.vala"
		_tmp1_ = self->priv->title_spinner;
#line 93 "../src/window/ImageDescriptionWindow.vala"
		gtk_stack_set_visible_child (_tmp0_, (GtkWidget*) _tmp1_);
#line 94 "../src/window/ImageDescriptionWindow.vala"
		_tmp2_ = self->priv->title_spinner;
#line 94 "../src/window/ImageDescriptionWindow.vala"
		gtk_spinner_start (_tmp2_);
#line 95 "../src/window/ImageDescriptionWindow.vala"
		_tmp3_ = self->priv->save_button;
#line 95 "../src/window/ImageDescriptionWindow.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
#line 592 "ImageDescriptionWindow.c"
	} else {
		GtkStack* _tmp4_;
		GtkLabel* _tmp5_;
		GtkSpinner* _tmp6_;
#line 97 "../src/window/ImageDescriptionWindow.vala"
		_tmp4_ = self->priv->title_stack;
#line 97 "../src/window/ImageDescriptionWindow.vala"
		_tmp5_ = self->priv->title_label;
#line 97 "../src/window/ImageDescriptionWindow.vala"
		gtk_stack_set_visible_child (_tmp4_, (GtkWidget*) _tmp5_);
#line 98 "../src/window/ImageDescriptionWindow.vala"
		_tmp6_ = self->priv->title_spinner;
#line 98 "../src/window/ImageDescriptionWindow.vala"
		gtk_spinner_stop (_tmp6_);
#line 99 "../src/window/ImageDescriptionWindow.vala"
		image_description_window_update_save_button_sensitivity (self);
#line 609 "ImageDescriptionWindow.c"
	}
#line 102 "../src/window/ImageDescriptionWindow.vala"
	_tmp7_ = self->priv->description_text;
#line 102 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp7_, !sending);
#line 615 "ImageDescriptionWindow.c"
}

static void
__lambda48_ (ImageDescriptionWindow* self,
             GObject* obj,
             GAsyncResult* res)
{
	gboolean success = FALSE;
	GError* _inner_error0_ = NULL;
#line 111 "../src/window/ImageDescriptionWindow.vala"
	g_return_if_fail (res != NULL);
#line 112 "../src/window/ImageDescriptionWindow.vala"
	success = FALSE;
#line 629 "ImageDescriptionWindow.c"
	{
#line 114 "../src/window/ImageDescriptionWindow.vala"
		image_description_window_set_image_description_finish (self, res, &_inner_error0_);
#line 114 "../src/window/ImageDescriptionWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 635 "ImageDescriptionWindow.c"
			goto __catch0_g_error;
		}
#line 115 "../src/window/ImageDescriptionWindow.vala"
		success = TRUE;
#line 640 "ImageDescriptionWindow.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
		GError* _tmp2_;
#line 113 "../src/window/ImageDescriptionWindow.vala"
		e = _inner_error0_;
#line 113 "../src/window/ImageDescriptionWindow.vala"
		_inner_error0_ = NULL;
#line 117 "../src/window/ImageDescriptionWindow.vala"
		_tmp0_ = e;
#line 117 "../src/window/ImageDescriptionWindow.vala"
		_tmp1_ = _tmp0_->message;
#line 117 "../src/window/ImageDescriptionWindow.vala"
		g_debug ("ImageDescriptionWindow.vala:117: Error setting description: %s", _tmp1_);
#line 118 "../src/window/ImageDescriptionWindow.vala"
		_tmp2_ = e;
#line 118 "../src/window/ImageDescriptionWindow.vala"
		utils_show_error_dialog (_tmp2_, (GtkWindow*) self, NULL, 0);
#line 119 "../src/window/ImageDescriptionWindow.vala"
		image_description_window_set_sending_state (self, FALSE);
#line 120 "../src/window/ImageDescriptionWindow.vala"
		_g_error_free0 (e);
#line 120 "../src/window/ImageDescriptionWindow.vala"
		return;
#line 669 "ImageDescriptionWindow.c"
	}
	__finally0:
#line 113 "../src/window/ImageDescriptionWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 113 "../src/window/ImageDescriptionWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 113 "../src/window/ImageDescriptionWindow.vala"
		g_clear_error (&_inner_error0_);
#line 113 "../src/window/ImageDescriptionWindow.vala"
		return;
#line 680 "ImageDescriptionWindow.c"
	}
#line 123 "../src/window/ImageDescriptionWindow.vala"
	if (success) {
#line 684 "ImageDescriptionWindow.c"
		GtkTextView* _tmp3_;
		GtkTextBuffer* _tmp4_;
		GtkTextBuffer* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 124 "../src/window/ImageDescriptionWindow.vala"
		g_debug ("ImageDescriptionWindow.vala:124: Image description set");
#line 125 "../src/window/ImageDescriptionWindow.vala"
		_tmp3_ = self->priv->description_text;
#line 125 "../src/window/ImageDescriptionWindow.vala"
		_tmp4_ = gtk_text_view_get_buffer (_tmp3_);
#line 125 "../src/window/ImageDescriptionWindow.vala"
		_tmp5_ = _tmp4_;
#line 125 "../src/window/ImageDescriptionWindow.vala"
		g_object_get (_tmp5_, "text", &_tmp6_, NULL);
#line 125 "../src/window/ImageDescriptionWindow.vala"
		_tmp7_ = _tmp6_;
#line 125 "../src/window/ImageDescriptionWindow.vala"
		_tmp8_ = _tmp7_;
#line 125 "../src/window/ImageDescriptionWindow.vala"
		g_signal_emit (self, image_description_window_signals[IMAGE_DESCRIPTION_WINDOW_DESCRIPTION_UPDATED_SIGNAL], 0, self->priv->media_id, _tmp8_);
#line 125 "../src/window/ImageDescriptionWindow.vala"
		_g_free0 (_tmp8_);
#line 126 "../src/window/ImageDescriptionWindow.vala"
		gtk_widget_hide ((GtkWidget*) self);
#line 127 "../src/window/ImageDescriptionWindow.vala"
		g_debug ("ImageDescriptionWindow.vala:127: Hidden");
#line 713 "ImageDescriptionWindow.c"
	} else {
#line 129 "../src/window/ImageDescriptionWindow.vala"
		g_debug ("ImageDescriptionWindow.vala:129: Image description failed");
#line 130 "../src/window/ImageDescriptionWindow.vala"
		image_description_window_set_sending_state (self, FALSE);
#line 719 "ImageDescriptionWindow.c"
	}
}

static void
___lambda48__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 111 "../src/window/ImageDescriptionWindow.vala"
	__lambda48_ ((ImageDescriptionWindow*) self, source_object, res);
#line 111 "../src/window/ImageDescriptionWindow.vala"
	g_object_unref (self);
#line 732 "ImageDescriptionWindow.c"
}

static void
image_description_window_save_image_description_clicked (ImageDescriptionWindow* self)
{
	GtkButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 106 "../src/window/ImageDescriptionWindow.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/window/ImageDescriptionWindow.vala"
	_tmp0_ = self->priv->save_button;
#line 107 "../src/window/ImageDescriptionWindow.vala"
	_tmp1_ = gtk_widget_get_sensitive ((GtkWidget*) _tmp0_);
#line 107 "../src/window/ImageDescriptionWindow.vala"
	_tmp2_ = _tmp1_;
#line 107 "../src/window/ImageDescriptionWindow.vala"
	if (!_tmp2_) {
#line 108 "../src/window/ImageDescriptionWindow.vala"
		return;
#line 753 "ImageDescriptionWindow.c"
	}
#line 110 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_set_sending_state (self, TRUE);
#line 111 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_set_image_description (self, ___lambda48__gasync_ready_callback, g_object_ref (self));
#line 759 "ImageDescriptionWindow.c"
}

static void
_image_description_window_save_image_description_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self)
{
#line 19 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_save_image_description_clicked ((ImageDescriptionWindow*) self);
#line 768 "ImageDescriptionWindow.c"
}

static void
image_description_window_set_image_description_data_free (gpointer _data)
{
	ImageDescriptionWindowSetImageDescriptionData* _data_;
	_data_ = _data;
#line 19 "../src/window/ImageDescriptionWindow.vala"
	_g_object_unref0 (_data_->self);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	g_slice_free (ImageDescriptionWindowSetImageDescriptionData, _data_);
#line 780 "ImageDescriptionWindow.c"
}

static void
image_description_window_set_image_description (ImageDescriptionWindow* self,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_)
{
	ImageDescriptionWindowSetImageDescriptionData* _data_;
	ImageDescriptionWindow* _tmp0_;
#line 19 "../src/window/ImageDescriptionWindow.vala"
	g_return_if_fail (self != NULL);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	_data_ = g_slice_new0 (ImageDescriptionWindowSetImageDescriptionData);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	g_task_set_task_data (_data_->_async_result, _data_, image_description_window_set_image_description_data_free);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	_data_->self = _tmp0_;
#line 19 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_set_image_description_co (_data_);
#line 804 "ImageDescriptionWindow.c"
}

static void
image_description_window_set_image_description_finish (ImageDescriptionWindow* self,
                                                       GAsyncResult* _res_,
                                                       GError** error)
{
	ImageDescriptionWindowSetImageDescriptionData* _data_;
#line 19 "../src/window/ImageDescriptionWindow.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	if (NULL == _data_) {
#line 19 "../src/window/ImageDescriptionWindow.vala"
		return;
#line 819 "ImageDescriptionWindow.c"
	}
}

static Block96Data*
block96_data_ref (Block96Data* _data96_)
{
#line 135 "../src/window/ImageDescriptionWindow.vala"
	g_atomic_int_inc (&_data96_->_ref_count_);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	return _data96_;
#line 830 "ImageDescriptionWindow.c"
}

static void
block96_data_unref (void * _userdata_)
{
	Block96Data* _data96_;
	_data96_ = (Block96Data*) _userdata_;
#line 135 "../src/window/ImageDescriptionWindow.vala"
	if (g_atomic_int_dec_and_test (&_data96_->_ref_count_)) {
#line 840 "ImageDescriptionWindow.c"
		ImageDescriptionWindow* self;
#line 135 "../src/window/ImageDescriptionWindow.vala"
		self = _data96_->self;
#line 135 "../src/window/ImageDescriptionWindow.vala"
		_g_error_free0 (_data96_->err);
#line 135 "../src/window/ImageDescriptionWindow.vala"
		_g_object_unref0 (_data96_->call);
#line 135 "../src/window/ImageDescriptionWindow.vala"
		_g_object_unref0 (self);
#line 135 "../src/window/ImageDescriptionWindow.vala"
		g_slice_free (Block96Data, _data96_);
#line 852 "ImageDescriptionWindow.c"
	}
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 144 "../src/window/ImageDescriptionWindow.vala"
	return self ? json_object_ref (self) : NULL;
#line 861 "ImageDescriptionWindow.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 159 "../src/window/ImageDescriptionWindow.vala"
	return self ? g_error_copy (self) : NULL;
#line 869 "ImageDescriptionWindow.c"
}

static void
__lambda47_ (Block96Data* _data96_,
             GObject* obj,
             GAsyncResult* res)
{
	ImageDescriptionWindow* self;
	GError* _inner_error0_ = NULL;
#line 153 "../src/window/ImageDescriptionWindow.vala"
	self = _data96_->self;
#line 153 "../src/window/ImageDescriptionWindow.vala"
	g_return_if_fail (res != NULL);
#line 883 "ImageDescriptionWindow.c"
	{
		OAuthProxyCallWithBody* _tmp0_;
#line 155 "../src/window/ImageDescriptionWindow.vala"
		g_debug ("ImageDescriptionWindow.vala:155: Call completed");
#line 156 "../src/window/ImageDescriptionWindow.vala"
		_tmp0_ = _data96_->call;
#line 156 "../src/window/ImageDescriptionWindow.vala"
		rest_proxy_call_invoke_finish ((RestProxyCall*) _tmp0_, res, &_inner_error0_);
#line 156 "../src/window/ImageDescriptionWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 894 "ImageDescriptionWindow.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 154 "../src/window/ImageDescriptionWindow.vala"
		e = _inner_error0_;
#line 154 "../src/window/ImageDescriptionWindow.vala"
		_inner_error0_ = NULL;
#line 158 "../src/window/ImageDescriptionWindow.vala"
		_tmp1_ = e;
#line 158 "../src/window/ImageDescriptionWindow.vala"
		_tmp2_ = _tmp1_->message;
#line 158 "../src/window/ImageDescriptionWindow.vala"
		g_debug ("ImageDescriptionWindow.vala:158: ERROR! %s", _tmp2_);
#line 159 "../src/window/ImageDescriptionWindow.vala"
		_tmp3_ = e;
#line 159 "../src/window/ImageDescriptionWindow.vala"
		_tmp4_ = _g_error_copy0 (_tmp3_);
#line 159 "../src/window/ImageDescriptionWindow.vala"
		_g_error_free0 (_data96_->err);
#line 159 "../src/window/ImageDescriptionWindow.vala"
		_data96_->err = _tmp4_;
#line 154 "../src/window/ImageDescriptionWindow.vala"
		_g_error_free0 (e);
#line 926 "ImageDescriptionWindow.c"
	}
	__finally0:
#line 154 "../src/window/ImageDescriptionWindow.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 154 "../src/window/ImageDescriptionWindow.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 154 "../src/window/ImageDescriptionWindow.vala"
		g_clear_error (&_inner_error0_);
#line 154 "../src/window/ImageDescriptionWindow.vala"
		return;
#line 937 "ImageDescriptionWindow.c"
	}
#line 161 "../src/window/ImageDescriptionWindow.vala"
	g_debug ("ImageDescriptionWindow.vala:161: Callback");
#line 162 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_set_image_description_co (_data96_->_async_data_);
#line 943 "ImageDescriptionWindow.c"
}

static void
___lambda47__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 153 "../src/window/ImageDescriptionWindow.vala"
	__lambda47_ (self, source_object, res);
#line 153 "../src/window/ImageDescriptionWindow.vala"
	block96_data_unref (self);
#line 955 "ImageDescriptionWindow.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 169 "../src/window/ImageDescriptionWindow.vala"
	g_boxed_free (json_node_get_type (), self);
#line 963 "ImageDescriptionWindow.c"
}

static gboolean
image_description_window_set_image_description_co (ImageDescriptionWindowSetImageDescriptionData* _data_)
{
#line 135 "../src/window/ImageDescriptionWindow.vala"
	switch (_data_->_state_) {
#line 135 "../src/window/ImageDescriptionWindow.vala"
		case 0:
#line 973 "ImageDescriptionWindow.c"
		goto _state_0;
#line 135 "../src/window/ImageDescriptionWindow.vala"
		case 1:
#line 977 "ImageDescriptionWindow.c"
		goto _state_1;
		default:
#line 135 "../src/window/ImageDescriptionWindow.vala"
		g_assert_not_reached ();
#line 982 "ImageDescriptionWindow.c"
	}
	_state_0:
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_data_->_data96_ = g_slice_new0 (Block96Data);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_data_->_data96_->_ref_count_ = 1;
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_data_->_data96_->self = g_object_ref (_data_->self);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_data_->_data96_->_async_data_ = _data_;
#line 136 "../src/window/ImageDescriptionWindow.vala"
	g_debug ("ImageDescriptionWindow.vala:136: Creating JSON");
#line 137 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp0_ = json_generator_new ();
#line 137 "../src/window/ImageDescriptionWindow.vala"
	_data_->gen = _data_->_tmp0_;
#line 138 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp1_ = json_node_new (JSON_NODE_OBJECT);
#line 138 "../src/window/ImageDescriptionWindow.vala"
	_data_->root = _data_->_tmp1_;
#line 139 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp2_ = json_object_new ();
#line 139 "../src/window/ImageDescriptionWindow.vala"
	_data_->object = _data_->_tmp2_;
#line 140 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp3_ = _data_->root;
#line 140 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp4_ = _data_->object;
#line 140 "../src/window/ImageDescriptionWindow.vala"
	json_node_set_object (_data_->_tmp3_, _data_->_tmp4_);
#line 141 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp5_ = _data_->gen;
#line 141 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp6_ = _data_->root;
#line 141 "../src/window/ImageDescriptionWindow.vala"
	json_generator_set_root (_data_->_tmp5_, _data_->_tmp6_);
#line 142 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp7_ = _data_->object;
#line 142 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp8_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->self->priv->media_id);
#line 142 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 142 "../src/window/ImageDescriptionWindow.vala"
	json_object_set_string_member (_data_->_tmp7_, "media_id", _data_->_tmp9_);
#line 142 "../src/window/ImageDescriptionWindow.vala"
	_g_free0 (_data_->_tmp9_);
#line 143 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp10_ = json_object_new ();
#line 143 "../src/window/ImageDescriptionWindow.vala"
	_data_->alt_text = _data_->_tmp10_;
#line 144 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp11_ = _data_->object;
#line 144 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp12_ = _data_->alt_text;
#line 144 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp13_ = _json_object_ref0 (_data_->_tmp12_);
#line 144 "../src/window/ImageDescriptionWindow.vala"
	json_object_set_object_member (_data_->_tmp11_, "alt_text", _data_->_tmp13_);
#line 145 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp14_ = _data_->alt_text;
#line 145 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp15_ = _data_->self->priv->description_text;
#line 145 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp16_ = gtk_text_view_get_buffer (_data_->_tmp15_);
#line 145 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 145 "../src/window/ImageDescriptionWindow.vala"
	g_object_get (_data_->_tmp17_, "text", &_data_->_tmp18_, NULL);
#line 145 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 145 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 145 "../src/window/ImageDescriptionWindow.vala"
	json_object_set_string_member (_data_->_tmp14_, "text", _data_->_tmp20_);
#line 145 "../src/window/ImageDescriptionWindow.vala"
	_g_free0 (_data_->_tmp20_);
#line 146 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp21_ = _data_->gen;
#line 146 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp22_ = json_generator_to_data (_data_->_tmp21_, NULL);
#line 146 "../src/window/ImageDescriptionWindow.vala"
	_data_->json_dump = _data_->_tmp22_;
#line 147 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp23_ = _data_->json_dump;
#line 147 "../src/window/ImageDescriptionWindow.vala"
	g_debug ("ImageDescriptionWindow.vala:147: Sending %s", _data_->_tmp23_);
#line 149 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp24_ = _data_->self->priv->proxy;
#line 149 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp25_ = _data_->json_dump;
#line 149 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp26_ = oauth_proxy_call_with_body_new ((RestProxy*) _data_->_tmp24_, _data_->_tmp25_);
#line 149 "../src/window/ImageDescriptionWindow.vala"
	_data_->_data96_->call = _data_->_tmp26_;
#line 150 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp27_ = _data_->_data96_->call;
#line 150 "../src/window/ImageDescriptionWindow.vala"
	rest_proxy_call_set_method ((RestProxyCall*) _data_->_tmp27_, "POST");
#line 151 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp28_ = _data_->_data96_->call;
#line 151 "../src/window/ImageDescriptionWindow.vala"
	rest_proxy_call_set_function ((RestProxyCall*) _data_->_tmp28_, "1.1/media/metadata/create.json");
#line 152 "../src/window/ImageDescriptionWindow.vala"
	_data_->_data96_->err = NULL;
#line 153 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp29_ = _data_->_data96_->call;
#line 153 "../src/window/ImageDescriptionWindow.vala"
	rest_proxy_call_invoke_async ((RestProxyCall*) _data_->_tmp29_, NULL, ___lambda47__gasync_ready_callback, block96_data_ref (_data_->_data96_));
#line 165 "../src/window/ImageDescriptionWindow.vala"
	g_debug ("ImageDescriptionWindow.vala:165: Yielding");
#line 166 "../src/window/ImageDescriptionWindow.vala"
	_data_->_state_ = 1;
#line 166 "../src/window/ImageDescriptionWindow.vala"
	return FALSE;
#line 1097 "ImageDescriptionWindow.c"
	_state_1:
	;
#line 168 "../src/window/ImageDescriptionWindow.vala"
	_data_->_tmp30_ = _data_->_data96_->err;
#line 168 "../src/window/ImageDescriptionWindow.vala"
	if (_data_->_tmp30_ != NULL) {
#line 169 "../src/window/ImageDescriptionWindow.vala"
		_data_->_tmp31_ = _data_->_data96_->err;
#line 169 "../src/window/ImageDescriptionWindow.vala"
		_data_->_tmp32_ = _g_error_copy0 (_data_->_tmp31_);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		_data_->_inner_error0_ = _data_->_tmp32_;
#line 169 "../src/window/ImageDescriptionWindow.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		_g_free0 (_data_->json_dump);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		_json_object_unref0 (_data_->alt_text);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		_json_object_unref0 (_data_->object);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		__vala_JsonNode_free0 (_data_->root);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		_g_object_unref0 (_data_->gen);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		block96_data_unref (_data_->_data96_);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		_data_->_data96_ = NULL;
#line 169 "../src/window/ImageDescriptionWindow.vala"
		g_object_unref (_data_->_async_result);
#line 169 "../src/window/ImageDescriptionWindow.vala"
		return FALSE;
#line 1130 "ImageDescriptionWindow.c"
	}
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_g_free0 (_data_->json_dump);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_json_object_unref0 (_data_->alt_text);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_json_object_unref0 (_data_->object);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	__vala_JsonNode_free0 (_data_->root);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_g_object_unref0 (_data_->gen);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	block96_data_unref (_data_->_data96_);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	_data_->_data96_ = NULL;
#line 135 "../src/window/ImageDescriptionWindow.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	if (_data_->_state_ != 0) {
#line 135 "../src/window/ImageDescriptionWindow.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 135 "../src/window/ImageDescriptionWindow.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1154 "ImageDescriptionWindow.c"
		}
	}
#line 135 "../src/window/ImageDescriptionWindow.vala"
	g_object_unref (_data_->_async_result);
#line 135 "../src/window/ImageDescriptionWindow.vala"
	return FALSE;
#line 1161 "ImageDescriptionWindow.c"
}

static void
image_description_window_cancel_clicked (ImageDescriptionWindow* self)
{
	GCancellable* _tmp0_;
#line 174 "../src/window/ImageDescriptionWindow.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/window/ImageDescriptionWindow.vala"
	_tmp0_ = self->priv->cancellable;
#line 175 "../src/window/ImageDescriptionWindow.vala"
	if (_tmp0_ != NULL) {
#line 1174 "ImageDescriptionWindow.c"
		GCancellable* _tmp1_;
#line 176 "../src/window/ImageDescriptionWindow.vala"
		_tmp1_ = self->priv->cancellable;
#line 176 "../src/window/ImageDescriptionWindow.vala"
		g_cancellable_cancel (_tmp1_);
#line 1180 "ImageDescriptionWindow.c"
	}
#line 178 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_hide ((GtkWidget*) self);
#line 1184 "ImageDescriptionWindow.c"
}

static void
_image_description_window_cancel_clicked_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
#line 19 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_cancel_clicked ((ImageDescriptionWindow*) self);
#line 1193 "ImageDescriptionWindow.c"
}

static gboolean
image_description_window_escape_pressed_cb (ImageDescriptionWindow* self)
{
	gboolean result;
#line 181 "../src/window/ImageDescriptionWindow.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 182 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_cancel_clicked (self);
#line 183 "../src/window/ImageDescriptionWindow.vala"
	result = GDK_EVENT_STOP;
#line 183 "../src/window/ImageDescriptionWindow.vala"
	return result;
#line 1208 "ImageDescriptionWindow.c"
}

static void
g_cclosure_user_marshal_VOID__INT64_STRING (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT64_STRING) (gpointer data1, gint64 arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT64_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 19 "../src/window/ImageDescriptionWindow.vala"
	g_return_if_fail (n_param_values == 3);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 19 "../src/window/ImageDescriptionWindow.vala"
		data1 = closure->data;
#line 19 "../src/window/ImageDescriptionWindow.vala"
		data2 = param_values->data[0].v_pointer;
#line 1233 "ImageDescriptionWindow.c"
	} else {
#line 19 "../src/window/ImageDescriptionWindow.vala"
		data1 = param_values->data[0].v_pointer;
#line 19 "../src/window/ImageDescriptionWindow.vala"
		data2 = closure->data;
#line 1239 "ImageDescriptionWindow.c"
	}
#line 19 "../src/window/ImageDescriptionWindow.vala"
	callback = (GMarshalFunc_VOID__INT64_STRING) (marshal_data ? marshal_data : cc->callback);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	callback (data1, g_value_get_int64 (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 1245 "ImageDescriptionWindow.c"
}

static void
image_description_window_class_init (ImageDescriptionWindowClass * klass,
                                     gpointer klass_data)
{
#line 19 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	g_type_class_adjust_private_offset (klass, &ImageDescriptionWindow_private_offset);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = image_description_window_finalize;
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/image-description-window.ui");
#line 19 "../src/window/ImageDescriptionWindow.vala"
	image_description_window_signals[IMAGE_DESCRIPTION_WINDOW_DESCRIPTION_UPDATED_SIGNAL] = g_signal_new ("description-updated", TYPE_IMAGE_DESCRIPTION_WINDOW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT64_STRING, G_TYPE_NONE, 2, G_TYPE_INT64, G_TYPE_STRING);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image", FALSE, ImageDescriptionWindow_private_offset + G_STRUCT_OFFSET (ImageDescriptionWindowPrivate, image));
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "description_text", FALSE, ImageDescriptionWindow_private_offset + G_STRUCT_OFFSET (ImageDescriptionWindowPrivate, description_text));
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "length_label", FALSE, ImageDescriptionWindow_private_offset + G_STRUCT_OFFSET (ImageDescriptionWindowPrivate, length_label));
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "save_button", FALSE, ImageDescriptionWindow_private_offset + G_STRUCT_OFFSET (ImageDescriptionWindowPrivate, save_button));
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "title_spinner", FALSE, ImageDescriptionWindow_private_offset + G_STRUCT_OFFSET (ImageDescriptionWindowPrivate, title_spinner));
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "title_label", FALSE, ImageDescriptionWindow_private_offset + G_STRUCT_OFFSET (ImageDescriptionWindowPrivate, title_label));
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "title_stack", FALSE, ImageDescriptionWindow_private_offset + G_STRUCT_OFFSET (ImageDescriptionWindowPrivate, title_stack));
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "save_image_description_clicked", G_CALLBACK(_image_description_window_save_image_description_clicked_gtk_button_clicked));
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel_clicked", G_CALLBACK(_image_description_window_cancel_clicked_gtk_button_clicked));
#line 1280 "ImageDescriptionWindow.c"
}

static void
image_description_window_instance_init (ImageDescriptionWindow * self,
                                        gpointer klass)
{
#line 19 "../src/window/ImageDescriptionWindow.vala"
	self->priv = image_description_window_get_instance_private (self);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	g_type_ensure (TYPE_RESIZABLE_IMAGE);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1293 "ImageDescriptionWindow.c"
}

static void
image_description_window_finalize (GObject * obj)
{
	ImageDescriptionWindow * self;
#line 19 "../src/window/ImageDescriptionWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_DESCRIPTION_WINDOW, ImageDescriptionWindow);
#line 40 "../src/window/ImageDescriptionWindow.vala"
	_g_object_unref0 (self->priv->proxy);
#line 41 "../src/window/ImageDescriptionWindow.vala"
	_g_object_unref0 (self->priv->cancellable);
#line 19 "../src/window/ImageDescriptionWindow.vala"
	G_OBJECT_CLASS (image_description_window_parent_class)->finalize (obj);
#line 1308 "ImageDescriptionWindow.c"
}

static GType
image_description_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ImageDescriptionWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_description_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageDescriptionWindow), 0, (GInstanceInitFunc) image_description_window_instance_init, NULL };
	GType image_description_window_type_id;
	image_description_window_type_id = g_type_register_static (gtk_window_get_type (), "ImageDescriptionWindow", &g_define_type_info, 0);
	ImageDescriptionWindow_private_offset = g_type_add_instance_private (image_description_window_type_id, sizeof (ImageDescriptionWindowPrivate));
	return image_description_window_type_id;
}

GType
image_description_window_get_type (void)
{
	static volatile gsize image_description_window_type_id__once = 0;
	if (g_once_init_enter (&image_description_window_type_id__once)) {
		GType image_description_window_type_id;
		image_description_window_type_id = image_description_window_get_type_once ();
		g_once_init_leave (&image_description_window_type_id__once, image_description_window_type_id);
	}
	return image_description_window_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

